include "semaphore_utils.iol"
include "../AbstractActivity.iol"

type OpType:void {
  .msgID:string
  .content?:undefined
}

type CoordType:void {
  .rolesNum:int
  .hasAck?:bool
  .sid:string
}

type JoinType:void {
  .sid:string
}

interface MHInterface {
OneWay:
  initStartProcedure( CoordType )
RequestResponse:
  response( OpType )( undefined ), joinAck( JoinType )( void ), joinStart( JoinType )( void ), get_response( OpType )( undefined )
}

outputPort MH {
Interfaces: MHInterface
}

embedded {
Jolie : "__activity_manager/activities/bd13e47a-8cfb-4ba2-9851-1af43abf7376/mh.ol" in MH
}

outputPort Leader {
Protocol: sodep
RequestResponse:
  joinAck( JoinType )( void ), joinStart( JoinType )( void )
}

inputPort MyInputPort {
Location: "local"
Protocol: sodep
Interfaces: AdaptActivityInterface
Aggregates: MH
}


define onRun
{
  csets.cookie = "bd13e47a-8cfb-4ba2-9851-1af43abf7376";
  var298.sid = "bd13e47a-8cfb-4ba2-9851-1af43abf7376";
  Leader.location = "socket://localhost:10501/";
  joinStart@Leader( var298 )(  );
  [ adapt( eReq )(  ) {
  for ( c = 0, c < #eReq.code, c++ ){
    embed_scope@ActivityManager( eReq.code[ c ] )(  )
  }
} ] {
    var297.sid = "bd13e47a-8cfb-4ba2-9851-1af43abf7376_adapt";
    joinStart@Leader( var297 )(  );
    run@ActivityManager( eReq.main_key )(  )
  }
  [ noAdapt(  ) ] {
    var294.msgID = "2aa5054f-1a56-4b45-aa99-0cb869b73be4";
    get_response@MH( var294 )( var294 );
    var295 = var294.content;
    var296.value = var295;
    var296 = "result";
    set@State( var296 )(  )
  };
  var299.sid = "bd13e47a-8cfb-4ba2-9851-1af43abf7376";
  joinAck@Leader( var299 )(  )
}

define start
{
  nullProcess
}

